
// Variables that are used on both client and server

AddCSLuaFile( "shared.lua" )

SWEP.Author			= "Sippeangelo"
SWEP.Instructions	= "Click to throw. Right click to roll. Keep away from face."
SWEP.Contact            = "Facepunch"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_magnade.mdl"
SWEP.WorldModel			= "models/weapons/w_magnade.mdl"

SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo			= "none"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.PrintName			= "Flechette Grenade"			
SWEP.Slot				= 1
SWEP.SlotPos			= 2
SWEP.DrawAmmo			= false
SWEP.DrawCrosshair		= true

/*---------------------------------------------------------
	Reload
---------------------------------------------------------*/
function SWEP:Reload()

end

/*---------------------------------------------------------
	Think
---------------------------------------------------------*/
function SWEP:Think()

end


function SWEP:Draw()
	self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
end

/*---------------------------------------------------------
	PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()
	self.Weapon:SetNextPrimaryFire( CurTime() + 2 )
	self:EmitSound("weapons/grenade/tick1.wav")

	if (!SERVER) then return end

	local ent = ents.Create("FlechetteGrenade")
	ent:SetPos(self.Owner:GetShootPos())
	ent:SetAngles(Angle(math.random(1, 360), math.random(1, 360), math.random(1, 360)))
	ent:SetOwner(self.Weapon:GetOwner())
	ent:Spawn()
	ent:Activate()

	ent:GetPhysicsObject():ApplyForceCenter(self.Owner:GetAimVector() * 2500)

	self.Weapon:SendWeaponAnim(ACT_VM_THROW)
	self.Weapon:SendWeaponAnim(ACT_WM_THROW)

	timer.Simple(3, function()
			local effectdata = EffectData()
		 	effectdata:SetOrigin(ent:GetPos())
 			util.Effect("Explosion", effectdata, true, true)
			end)

	timer.Simple(1, function()
				if (self.Weapon:GetOwner():GetActiveWeapon() == self.Weapon) then
					self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
				end
			end)
end


/*---------------------------------------------------------
	SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
	self.Weapon:SetNextSecondaryFire( CurTime() + 2 )
	self:EmitSound("weapons/grenade/tick1.wav")

	if (!SERVER) then return end

	local ent = ents.Create("FlechetteGrenade")
	ent:SetPos(self.Owner:GetShootPos() + Vector(0, 0, -20))
	ent:SetAngles(self.Owner:EyeAngles())
	ent:SetOwner(self.Weapon:GetOwner())
	ent:Spawn()
	ent:Activate()

	ent:GetPhysicsObject():ApplyForceCenter(self.Owner:GetAimVector() * 700)

	self.Weapon:SendWeaponAnim(ACT_VM_SECONDARYATTACK)

	timer.Simple(3, function()
			local effectdata = EffectData()
		 	effectdata:SetOrigin(ent:GetPos())
 			util.Effect("Explosion", effectdata, true, true)
			end)

	timer.Simple(1, function()
				if (self.Weapon:GetOwner():GetActiveWeapon() == self.Weapon) then
					self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
				end
			end)

end

/*---------------------------------------------------------
	IdleAnimation
---------------------------------------------------------*/
function SWEP:IdleAnimation()
	self.Weapon:SendWeaponAnim(ACT_VM_IDLE) 
end

function SWEP:Initialize()
	if (CLIENT) then return end

	self:SetWeaponHoldType("grenade")

	self.Weapon:SendWeaponAnim(ACT_VM_DRAW)

end 