
// Variables that are used on both client and server

AddCSLuaFile( "shared.lua" )

SWEP.Author			= "Garry Newman\nModded by: Sp!ke\n"
SWEP.Purpose	= "Shoots flechettes shotgun-style"
SWEP.Instructions = "Primary Fire: Shoots a 6-shell Flechette\nSecondary Fire: Shoots a 12-shell Flechette"
SWEP.Spawnable			= false
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_shotgun.mdl"
SWEP.WorldModel			= "models/weapons/w_shotgun.mdl"

SWEP.Primary.ClipSize		= 8
SWEP.Primary.DefaultClip	= 32
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo			= "Flechettes"

SWEP.Primary.ClipSize		= 8
SWEP.Primary.DefaultClip	= 32
SWEP.Secondary.Automatic	= true
SWEP.Secondary.Ammo			= "Flechettes"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.PrintName			= "Flechette Shotgun"			
SWEP.Slot				= 1
SWEP.SlotPos			= 3
SWEP.DrawAmmo			= true
SWEP.DrawCrosshair		= true


local ShootSound = Sound( "NPC_Hunter.FlechetteShoot" )

/*---------------------------------------------------------
	Reload does nothing
---------------------------------------------------------*/
function SWEP:Reload()
	self.Weapon:DefaultReload( ACT_VM_RELOAD );
end

/*---------------------------------------------------------
   Think does nothing
---------------------------------------------------------*/
function SWEP:Think()	
end


/*---------------------------------------------------------
	PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()
	self.Weapon:SetNextPrimaryFire( CurTime() + 1.2 )
	self.Weapon:SetNextSecondaryFire( CurTime() + 1.2 )
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )
	self:EmitSound("Weapon_Shotgun.Single")
	timer.Create("EmitSecondarySound", 0.4, 1, EmitSecondarySound, self)
	self:EmitSound( ShootSound )
	self.Owner:ViewPunch( Angle( -3, 0, 0 ) )
	self:ShootEffects( self )
	
	// The rest is only done on the server
	if (!SERVER) then return end
	
	self:TakePrimaryAmmo( 1 )
	
	local x
	for x = 1, 6 do
		local r1 = math.random(-400, 400) / 10000
		local r2 = math.random(-400, 400) / 10000
		local r3 = math.random(-400, 400) / 10000
		local Forward = self.Owner:EyeAngles():Forward() + Angle(r1, r2, r3)
		
		local ent = ents.Create( "hunter_flechette" )
		if ( ValidEntity( ent ) ) then
				ent:SetPos( self.Owner:GetShootPos() + Forward * 32 )
				ent:SetAngles( self.Owner:EyeAngles() )
			ent:Spawn()
			ent:SetVelocity( Forward * 2000 )
		end
		ent:SetOwner( self.Owner )
	end
end

function EmitSecondarySound(self)
	self:EmitSound("Weapon_Shotgun.Special1")
end

/*---------------------------------------------------------
	SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
	self.Weapon:SetNextPrimaryFire( CurTime() + 1.2 )
	self.Weapon:SetNextSecondaryFire( CurTime() + 1.2 )
	self.Weapon:SendWeaponAnim( ACT_VM_SECONDARYATTACK )
	self:EmitSound("Weapon_Shotgun.Double")
	timer.Create("EmitSecondarySound", 0.4, 1, EmitSecondarySound, self)
	self.BaseClass.ShootEffects(self)
 	self:EmitSound(ShootSound)
	self.Owner:ViewPunch( Angle( -4, 0, 0 ) )
	self:ShootEffects( self )
	
	// The rest is only done on the server
	if (!SERVER) then return end
	
	self:TakePrimaryAmmo( 2 )
	
	local x
	for x = 1, 12 do
		local r1 = math.random(-550, 550) / 10000
		local r2 = math.random(-550, 550) / 10000
		local r3 = math.random(-550, 550) / 10000
		local Forward = self.Owner:EyeAngles():Forward() + Angle(r1, r2, r3)
		
		local ent = ents.Create( "hunter_flechette" )
		if ( ValidEntity( ent ) ) then
				ent:SetPos( self.Owner:GetShootPos() + Forward * 32 )
				ent:SetAngles( self.Owner:EyeAngles() )
			ent:Spawn()
			ent:SetVelocity( Forward * 2000 )
		end
		ent:SetOwner( self.Owner )
	end
end


/*---------------------------------------------------------
   Name: ShouldDropOnDie
   Desc: Should this weapon be dropped when its owner dies?
---------------------------------------------------------*/
function SWEP:ShouldDropOnDie()
	return false
end
